      SUBROUTINE GUOUT
*.
*...GUOUT    User routine called at the end of each event
*.
*. SEQUENCE  : GCFLAG GCONST GCLIST GCKINE
*.           : LPFLAG NTUPLE RCREP  XECGEO XECINT XECSCI
*. CALLS     : GDAXIS GDRAWC GDRAWT GDXYZ
*.           : HFNT   ICLRWK USOUT  XEPLEV XSBGN  XSTRAK
*. CALLED    : GTRIG
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.02
*. CREATED   : 07-May-00
*. LAST MOD  : 28-Nov-00
*.
*. Modification Log.
*. 28-Nov-00   T.Mashimo       (V1.02) Fix a bug pointed out by ozone;
*.                             in the event display XCONV was used
*.                             instead of X1CONV.
*. 16-May-00   T.Mashimo       (V1.01) Initial volume name MEG -> LP.
*. 07-May-00   T.Mashimo       (V1.00) 1st version based on T. Mori's
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gckine.inc"
#include "geant321/gconst.inc"
#include "geant321/gcflag.inc"
#include "geant321/gclist.inc"
#include "lpflag.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "xecsci.inc"
#include "ntuple.inc"
#include "rcrep.inc"
*
      INTEGER I, J
      CHARACTER*35 COMMNT
*
*-- Draw this event
*
      IF (NPLOT .GT. 0 .AND.
     +    IEVENT .GE. LPLOT(1) .AND. IEVENT .LE. LPLOT(2)) THEN
         CALL ICLRWK(0, 0)  ! clear
*
         CALL GDRAWC('LP  ', 2, 3.0, 7.5, 15., 0.2, 0.2)    ! x-z plot
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)
         WRITE(COMMNT, '(''Converted:'',3F8.2)') (X1CONV(I),I=1,3)
*
         CALL GDRAWC('LP  ',1, 3.0, 7.5,  5., 0.2, 0.2)    ! y-z plot
         CALL GDAXIS(-20., -20., -25., 8.)
         CALL GDXYZ(0)
*
         WRITE(COMMNT, '(''Converted:'',3F8.2)') (X1CONV(I),I=1,3)
         CALL GDRAWT( 5.0,  9.8, COMMNT, 0.3, 0., 2, -1)
*
**       CALL ICLRWK(0, 0)  ! clear
*
**       CALL GDRAWC('LP  ', 2, 3.0, 20.0, 10., 1.0, 1.0)    ! x-z plot
      END IF
*
*-- No conversion or interaction 
*
      IF (X1INTR(3) .GT. 500.) THEN 
         WRITE(CHREP, '(''No interaction occurred'')') 
         CALL REPORT('GUOUT', 1, 'WARNING')
      END IF
      IF (X1CONV(3) .GT. 500.) THEN 
         WRITE(CHREP, '(''No conversion occurred'')') 
         CALL REPORT('GUOUT', 2, 'INFO')
      END IF
*
*-- Scintillation light tracking
*
      IF (ISCTRK .GT. 0) THEN
         CALL XSBGN
         DO 100 I = 1, NDEXE
            IF (XDEXE(1,I) .GT. WALL(1) .AND.
     +          XDEXE(1,I) .LT. WALL(2) .AND.
     +          XDEXE(2,I) .GT. WALL(3) .AND.
     +          XDEXE(2,I) .LT. WALL(4) .AND.
     +          XDEXE(3,I) .GT. WALL(5) .AND.
     +          XDEXE(3,I) .LT. WALL(6)) THEN
               NDEXES = NDEXES + 1
               CALL XSTRAK(XDEXE(1,I))
            END IF
  100    CONTINUE
      END IF
*
*-- Print the p.e. distribution graphically
*
**    CALL XEPLEV
*
*-- Fill ntuple
*
      IF (NTUPON .EQ. 1) THEN
         DEXE   = DEXESM
         DEPMT  = DEREST
         XCONV(1) = X1CONV(1)
         XCONV(2) = X1CONV(2)
         XCONV(3) = X1CONV(3)
         ZFIRST = X1INTR(3)
         NDEPO  = NDEXE
         DO 210 I = 1, NDEPO
         DO 210 J = 1, 4
            XDEPO(J,I) = XDEXE(J,I)
  210    CONTINUE
         NTOTPE = NPEGEN
         NSUM   = NPEALL
         DO 220 I = 1, NALPMT
            NPE(I) = NPEPMT(I)
  220    CONTINUE
         DO 230 I = 1, NWALL
            NPEW(I) = NPEWAL(I)
  230    CONTINUE
*
         CALL HFNT(IDNTPL)
      END IF
*
*-- Call user routine
*
      CALL USOUT
*
      RETURN
      END
