      SUBROUTINE UGINIT
*.
*...UGINIT   Initialization routine
*.
*. SEQUENCE  : GCLIST GCRZ
*.           : LPFLAG NTUPLE RCREP  XECGEO XECINT XECSCI
*. CALLS     : FFINIT FFKEY  FFSET  GDINIT GFFGO  GINIT  GMATE
*.           : GPART  GPHYSI GZINIT
*.           : LPGEOM
*.           : HBNAME HBNT   HBSET  HROPEN IGMETA
*.           : USIFFR USINIT VBLANK XSINIT
*. CALLED    : MAIN
*.
*. BANKS L   : None
*. BANKS U   : None
*.
*. AUTHOR    : T.Mashimo
*. VERSION   : 1.03
*. CREATED   : 06-May-00
*. LAST MOD  : 20-Mar-02
*.
*. Modification Log.
*. 20-Mar-02   K.Ozone         (V1.03) Added RZ file load for BSC
*. 08-Mar-02   K.Ozone         (V1.02) Adapted BSCON switch
*. 02-Aug-01   K.Ozone         (V1.01) Support for Comptom edge
*.                             distributions
*. 06-May-00   T.Mashimo       (V1.00) First version.
*.
*.**********************************************************************
*.
#include "declare.inc"
#include "geant321/gclist.inc"
#include "geant321/gcrz.inc"
#include "geant321/gckine.inc"
#include "lpflag.inc"
#include "xecgeo.inc"
#include "xecint.inc"
#include "ntuple.inc"
#include "rcrep.inc"
#include "cmpedg.inc"
*
      REAL    FFSPAC
      COMMON /CFREAD/ FFSPAC(15000)
*
      INTEGER IQUEST, IERR
      COMMON /QUEST/ IQUEST(100)
*
      CHARACTER*80 CPSNAM, CHBNAM
      CHARACTER*4  CMXPMT, CMXDEP
      CHARACTER*500 CHFORM
      CHARACTER*80 BSCNAM
*
*
      EXTERNAL CMPEDG
*
*-- Initialize GEANT
*
      CALL GINIT
*
*--   Reinitialize FFREAD with more space/ 12 character names
*
      CALL FFINIT(15000)
      CALL FFSET('SIZE', 12)
*
*-- Define LP's FFREAD data cards
*
      CALL LPIFFR
*
      CALL GFFGO
*
*-- Initialize data structure
*
      CALL GZINIT
*
*-- Initialize graphics
*
      CALL UHTOC(LPSNAM, 4, CPSNAM, NAMLEN)
      IF (CPSNAM .NE. ' ') THEN
         OPEN(LUNPS, FILE=CPSNAM,
     +               STATUS='UNKNOWN', FORM='FORMATTED')
         CALL IGMETA(-LUNPS, -111)
      END IF
*
      CALL GDINIT
*
*-- Particle table initialization
*
      CALL GPART
*
*-- Define standard materials
*
      CALL GMATE
*
*-- Geometry and materials description
*
      CALL LPGEOM
*
*-- Energy loss and cross-sections tables
*
      CALL GPHYSI
*
*-- Print banks
*
      CALL GPRINT('MATE', 0)
      CALL GPRINT('TMED', 0)
      CALL GPRINT('VOLU', 0)
*
*-- Open an output HBOOK file
*
      CALL UHTOC(LHBNAM, 4, CHBNAM, NAMLEN)
      IF (CHBNAM .NE. ' ') THEN
         CALL HBSET('BSIZE', NRECNT, IERR)
         IQUEST(10) = MXRCNT
         CALL HROPEN(LUNHBK, 'HISTO', CHBNAM, 'NQ', NRECNT, IERR)
         IF (NTUPON .EQ. 1) THEN
            CALL HBNT(IDNTPL, TITLNT, ' ')
            NNPE = MXPMTS
            WRITE(CMXPMT, '(I4)') MXPMTS
            WRITE(CMXDEP, '(I4)') MXDEPO
            CHFORM =
     +        'EVENT:I,EIN,XIN,YIN,THIN'//
     +       ',DEXE,DEPMT,XCONV(3),ZFIRST,NTOTPE'//
     +       ',NSUM,NPEW(6),NNPE[0,'//CMXPMT//'],NPE(NNPE)'//
     +       ',NDEPO[0,'//CMXDEP//'],XDEPO(4,NDEPO)'
            CALL HBNAME(IDNTPL, CBLKDA, EVENT, CHFORM)
         END IF
      ELSE
         NTUPON = 0
      END IF
*
*-- Print parameters for the run
*
      IF (NTUPON .EQ. 0) THEN
         WRITE(CHREP, '(''Ntuple creation: OFF'')' )
      ELSE
         WRITE(CHREP, '(''Ntuple creation: ON'')' )
      END IF
      CALL REPORT('UGINIT', 1, 'INFO')
*
      IF (NPLOT .LE. 0) THEN
         WRITE(CHREP, '(''Event plotting: OFF'')' )
         CALL REPORT('UGINIT', 2, 'INFO')
      ELSE
         WRITE(CHREP,
     +        '(''Event plotting: ON for events '', I8, ''-'', I8)' )
     +         LPLOT(1), LPLOT(2)
         CALL REPORT('UGINIT', 2, 'INFO')
         WRITE(CHREP,
     +        '(''P cut for GSXYZ in GUSTEP: '', F10.3, '' MeV'')')
     +         CUTXYZ
         CALL REPORT('UGINIT', 3, 'INFO')
      END IF
*
      CALL XEGPAR
*
*-- Initialize XS (Xe scintillation photon tracking)
*
      CALL XSINIT
*
*-- Event number in /NTUPLE/
*
      EVENT = 0
*
*-- Define user function of gamma energy and make a dist. table
*
      IF (IKINE .LT. 0 .AND. IKINE .GE. -3000) THEN
         IF (BSCON .NE. 0) THEN
            WRITE(CHREP, '(''Back Scattered Compton: ON'')' )
            CALL REPORT('UGINIT', 4, 'INFO')
            IF (BSCON .EQ. 1) THEN
               WRITE(CHREP,
     +              '(''E dist. RZ file: compton.rz'')')
               CALL REPORT('UGINIT', 4, 'INFO')
               CALL UHTOC(BSCRZ, 4, BSCNAM, NAMLEN)
               CALL HRGET(BSCHID, BSCNAM, ' ')
            ELSE IF (IKINE .GE. -1000) THEN
               WRITE(CHREP,
     +              '(''Energy: '', F8.2, '' MeV - '', F8.2, '' MeV'')')
     +              PKINE(4), PKINE(5)
               CALL REPORT('UGINIT', 4, 'INFO')
               CALL FUNLXP(CMPEDG, FSPACE, PKINE(4), PKINE(5))
            ELSE
               WRITE(CHREP,
     +              '(''Energy: '', F8.2, '' MeV - '', F8.2, '' MeV'')')
     +              PKINE(6), PKINE(7)
               CALL REPORT('UGINIT', 4, 'INFO')
               CALL FUNLXP(CMPEDG, FSPACE, PKINE(6), PKINE(7))
            END IF
         END IF
      END IF
*
*-- Call user initialization routine
*
      CALL USINIT
*
  999 CONTINUE
      RETURN
      END
